"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * This file was automatically generated by openapi-codegeneration.
 * DO NOT MODIFY IT BY HAND. Instead, modify the source OpenAPI file,
 * and run openapi-codegeneration to regenerate this file.
 */
const express_1 = __importDefault(require("express"));
const operations = __importStar(require("../operations"));
const types_1 = require("./types");
const requestValidation_1 = require("./requestValidation");
function routes(options = {
    security: {
        TuiAuth: (_req, _scopes) => {
            throw new Error("TuiAuth authentication not implemented");
        },
        AccessToken: (_req, _scopes) => {
            throw new Error("AccessToken authentication not implemented");
        },
        JWT: (_req, _scopes) => {
            throw new Error("JWT authentication not implemented");
        },
    },
}) {
    const router = express_1.default.Router();
    async function handleSecurityRequirement(request, securityRequirement) {
        let userData = {};
        for (const method in securityRequirement) {
            userData[method] = await options.security[method](request, securityRequirement[method]);
        }
        return userData;
    }
    router.get("/auth", async (req, res, next) => {
        const parameters = {
            Authorization: req.get("Authorization"),
            "X-Real-IP": req.get("X-Real-IP"),
            "X-Forwarded-Proto": req.get("X-Forwarded-Proto"),
        };
        try {
            if (!(0, requestValidation_1.validateGetAuthInput)(parameters)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validateGetAuthInput.errors, 400);
            }
            const result = await operations.getAuth(parameters);
            if (!(0, requestValidation_1.validateGetAuthOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validateGetAuthOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post("/login", async (req, res, next) => {
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePostLoginInput)(body)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validatePostLoginInput.errors, 400);
            }
            const result = await operations.postLogin(body);
            if (!(0, requestValidation_1.validatePostLoginOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validatePostLoginOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post("/logout", async (req, res, next) => {
        const security = [
            {
                JWT: ["logout"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePostLogoutInput)(body)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validatePostLogoutInput.errors, 400);
            }
            const result = await operations.postLogout(body, userData);
            if (!(0, requestValidation_1.validatePostLogoutOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validatePostLogoutOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post("/device_authentication_token", async (req, res, next) => {
        const security = [
            {
                JWT: ["device_token", "device_token:create"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const parameters = {
            device_url: req.query["device_url"],
        };
        try {
            if (!(0, requestValidation_1.validatePostDeviceAuthenticationTokenInput)(parameters)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validatePostDeviceAuthenticationTokenInput.errors, 400);
            }
            const result = await operations.postDeviceAuthenticationToken(parameters, userData);
            if (!(0, requestValidation_1.validatePostDeviceAuthenticationTokenOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validatePostDeviceAuthenticationTokenOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.get("/users", async (req, res, next) => {
        const security = [
            {
                JWT: ["users", "users:list"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        try {
            if (!(0, requestValidation_1.validateGetUsersInput)()) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validateGetUsersInput.errors, 400);
            }
            const result = await operations.getUsers(userData);
            if (!(0, requestValidation_1.validateGetUsersOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validateGetUsersOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post("/users", async (req, res, next) => {
        const security = [
            {
                JWT: ["users", "users:create"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePostUsersInput)(body)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validatePostUsersInput.errors, 400);
            }
            const result = await operations.postUsers(body, userData);
            if (!(0, requestValidation_1.validatePostUsersOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validatePostUsersOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.get("/users/:username", async (req, res, next) => {
        const security = [
            {
                JWT: ["users", "users:list"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const parameters = {
            username: req.params["username"],
        };
        try {
            if (!(0, requestValidation_1.validateGetUsersByUsernameInput)(parameters)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validateGetUsersByUsernameInput.errors, 400);
            }
            const result = await operations.getUsersByUsername(parameters, userData);
            if (!(0, requestValidation_1.validateGetUsersByUsernameOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validateGetUsersByUsernameOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.patch("/users/:username", async (req, res, next) => {
        const security = [
            {
                JWT: ["users", "users:edit"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const parameters = {
            username: req.params["username"],
        };
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePatchUsersByUsernameInput)(parameters, body)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validatePatchUsersByUsernameInput.errors, 400);
            }
            const result = await operations.patchUsersByUsername(parameters, body, userData);
            if (!(0, requestValidation_1.validatePatchUsersByUsernameOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validatePatchUsersByUsernameOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.delete("/users/:username", async (req, res, next) => {
        const security = [
            {
                JWT: ["users", "users:create"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const parameters = {
            username: req.params["username"],
        };
        try {
            if (!(0, requestValidation_1.validateDeleteUsersByUsernameInput)(parameters)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validateDeleteUsersByUsernameInput.errors, 400);
            }
            const result = await operations.deleteUsersByUsername(parameters, userData);
            if (!(0, requestValidation_1.validateDeleteUsersByUsernameOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validateDeleteUsersByUsernameOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.put("/users/:username/roles/:role_name", async (req, res, next) => {
        const security = [
            {
                JWT: ["users", "users:edit"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const parameters = {
            username: req.params["username"],
            role_name: req.params["role_name"],
        };
        try {
            if (!(0, requestValidation_1.validatePutUsersByUsernameRolesByRoleNameInput)(parameters)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validatePutUsersByUsernameRolesByRoleNameInput.errors, 400);
            }
            const result = await operations.putUsersByUsernameRolesByRoleName(parameters, userData);
            if (!(0, requestValidation_1.validatePutUsersByUsernameRolesByRoleNameOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validatePutUsersByUsernameRolesByRoleNameOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.delete("/users/:username/roles/:role_name", async (req, res, next) => {
        const security = [
            {
                JWT: ["users", "users:edit"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const parameters = {
            username: req.params["username"],
            role_name: req.params["role_name"],
        };
        try {
            if (!(0, requestValidation_1.validateDeleteUsersByUsernameRolesByRoleNameInput)(parameters)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validateDeleteUsersByUsernameRolesByRoleNameInput.errors, 400);
            }
            const result = await operations.deleteUsersByUsernameRolesByRoleName(parameters, userData);
            if (!(0, requestValidation_1.validateDeleteUsersByUsernameRolesByRoleNameOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validateDeleteUsersByUsernameRolesByRoleNameOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.get("/identity", async (req, res, next) => {
        const security = [
            {
                JWT: ["identity", "identity:list"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        try {
            if (!(0, requestValidation_1.validateGetIdentityInput)()) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validateGetIdentityInput.errors, 400);
            }
            const result = await operations.getIdentity(userData);
            if (!(0, requestValidation_1.validateGetIdentityOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validateGetIdentityOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.patch("/identity", async (req, res, next) => {
        const security = [
            {
                JWT: ["identity", "identity:edit"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePatchIdentityInput)(body)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validatePatchIdentityInput.errors, 400);
            }
            const result = await operations.patchIdentity(body, userData);
            if (!(0, requestValidation_1.validatePatchIdentityOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validatePatchIdentityOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    return router;
}
exports.default = routes;
//# sourceMappingURL=routes.js.map