"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isUserType = exports.ValidationError = exports.ErrorWithStatus = exports.isErrorResponse = exports.isSuccessResponse = void 0;
const basicValidation_1 = require("./basicValidation");
function isSuccessResponse(response) {
    return response.status < 400;
}
exports.isSuccessResponse = isSuccessResponse;
function isErrorResponse(response) {
    return response.status >= 400;
}
exports.isErrorResponse = isErrorResponse;
class ErrorWithStatus extends Error {
    constructor(message, status) {
        super(message);
        this.status = status;
        this.name = "ErrorWithStatus";
    }
}
exports.ErrorWithStatus = ErrorWithStatus;
class ValidationError extends ErrorWithStatus {
    constructor(message, errors, status) {
        super(message, status);
        this.name = "ValidationError";
        this.errors = errors;
    }
}
exports.ValidationError = ValidationError;
function isUserType(obj, type) {
    switch (type) {
        case "request":
            return (0, basicValidation_1.validateUserTypeRequest)(obj);
        case "response":
            return (0, basicValidation_1.validateUserTypeResponse)(obj);
        default:
            return (0, basicValidation_1.validateUserType)(obj);
    }
}
exports.isUserType = isUserType;
//# sourceMappingURL=types.js.map