"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.formatUser = exports.formatRole = exports.formatScope = void 0;
const globals_1 = require("../globals");
/**
 * This function formats a ScopeModel to a Scope.
 * @param scope The ScopeModel to be formatted.
 * @returns The resulting Scope.
 */
function formatScope(scope) {
    return scope.name;
}
exports.formatScope = formatScope;
/**
 * This function formats a RoleModel to a Role.
 * @param role The RoleModel to be formatted.
 * @returns The resulting Role.
 */
function formatRole(role) {
    return {
        name: role.name,
        scopes: role.scopes ? role.scopes.map(formatScope) : [],
    };
}
exports.formatRole = formatRole;
/**
 * This function formats a UserModel to an User
 * @param user The UserModel to be formatted.
 * @returns The resulting User.
 */
function formatUser(user) {
    return {
        url: (0, globals_1.userUrlFromUsername)(user.username),
        username: user.username,
        roles: user.roles ? user.roles.map(formatRole) : [],
    };
}
exports.formatUser = formatUser;
//# sourceMappingURL=format.js.map