"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ActiveKeyModel = exports.KeyModel = exports.TokenModel = exports.UserModel = exports.RoleModel = exports.ScopeModel = void 0;
const typeorm_1 = require("typeorm");
let ScopeModel = class ScopeModel {
};
__decorate([
    (0, typeorm_1.PrimaryColumn)(),
    __metadata("design:type", String)
], ScopeModel.prototype, "name", void 0);
ScopeModel = __decorate([
    (0, typeorm_1.Entity)()
], ScopeModel);
exports.ScopeModel = ScopeModel;
let RoleModel = class RoleModel {
};
__decorate([
    (0, typeorm_1.PrimaryColumn)(),
    __metadata("design:type", String)
], RoleModel.prototype, "name", void 0);
__decorate([
    (0, typeorm_1.ManyToMany)(() => UserModel, (user) => user.roles),
    __metadata("design:type", Array)
], RoleModel.prototype, "users", void 0);
__decorate([
    (0, typeorm_1.ManyToMany)(() => ScopeModel),
    (0, typeorm_1.JoinTable)(),
    __metadata("design:type", Array)
], RoleModel.prototype, "scopes", void 0);
RoleModel = __decorate([
    (0, typeorm_1.Entity)()
], RoleModel);
exports.RoleModel = RoleModel;
let UserModel = class UserModel {
};
__decorate([
    (0, typeorm_1.PrimaryColumn)(),
    __metadata("design:type", String)
], UserModel.prototype, "username", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], UserModel.prototype, "password", void 0);
__decorate([
    (0, typeorm_1.ManyToMany)(() => RoleModel, (role) => role.users),
    (0, typeorm_1.JoinTable)(),
    __metadata("design:type", Array)
], UserModel.prototype, "roles", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => TokenModel, (token) => token.user, {
        onDelete: 'CASCADE',
        cascade: true,
    }),
    __metadata("design:type", Array)
], UserModel.prototype, "tokens", void 0);
UserModel = __decorate([
    (0, typeorm_1.Entity)()
], UserModel);
exports.UserModel = UserModel;
let TokenModel = class TokenModel {
};
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)('uuid'),
    __metadata("design:type", String)
], TokenModel.prototype, "token", void 0);
__decorate([
    (0, typeorm_1.Column)('datetime', { nullable: true }),
    __metadata("design:type", String)
], TokenModel.prototype, "expiresOn", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], TokenModel.prototype, "device", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => UserModel, (user) => user.tokens),
    __metadata("design:type", UserModel)
], TokenModel.prototype, "user", void 0);
__decorate([
    (0, typeorm_1.ManyToMany)(() => ScopeModel),
    (0, typeorm_1.JoinTable)(),
    __metadata("design:type", Array)
], TokenModel.prototype, "scopes", void 0);
TokenModel = __decorate([
    (0, typeorm_1.Entity)()
], TokenModel);
exports.TokenModel = TokenModel;
let KeyModel = class KeyModel {
};
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)('uuid'),
    __metadata("design:type", String)
], KeyModel.prototype, "uuid", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], KeyModel.prototype, "use", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], KeyModel.prototype, "alg", void 0);
__decorate([
    (0, typeorm_1.Column)('text'),
    __metadata("design:type", String)
], KeyModel.prototype, "public_key", void 0);
__decorate([
    (0, typeorm_1.Column)('text'),
    __metadata("design:type", String)
], KeyModel.prototype, "private_key", void 0);
KeyModel = __decorate([
    (0, typeorm_1.Entity)()
], KeyModel);
exports.KeyModel = KeyModel;
let ActiveKeyModel = class ActiveKeyModel {
};
__decorate([
    (0, typeorm_1.PrimaryColumn)(),
    __metadata("design:type", String)
], ActiveKeyModel.prototype, "use", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => KeyModel),
    __metadata("design:type", KeyModel)
], ActiveKeyModel.prototype, "key", void 0);
ActiveKeyModel = __decorate([
    (0, typeorm_1.Entity)()
], ActiveKeyModel);
exports.ActiveKeyModel = ActiveKeyModel;
//# sourceMappingURL=model.js.map